#ifndef CLIST_H
#define CLIST_H

/** Linked list of int */
typedef struct link_s {
    int value;
    struct link_s* next;
} link_t;

link_t* list_new(int value); 
void list_append(link_t* head, int value); 
unsigned list_count(link_t* head);
int list_get(link_t* head, unsigned index);
void list_clear(link_t* link);

#endif /* CLIST_H */
